#include <avr/eeprom.h>
#include "pitches.h"
#include "tune.h"
#include <util/delay.h>
#include <avr/io.h>
//#include <pthread.h>
//#include <stdio.h>

long hz1(int tune)
{
	if (tune == _BLANK)
	{
		TCCR0B = 0b00000000;
	}
	else
	{
		TCCR0B = 0b00001100; //PD6
		OCR0A=(((16000000L/256)/2)/tune)-1;
	}	
}
long hz2(int tune)
{
	if (tune == _BLANK)
	{
		TCCR2B = 0b00000000;
	}
	else
	{
		TCCR2B = 0b00001100; //PC3
		OCR2A=(((16000000L/256)/2)/tune)-1;
	}	
}
void delay(int k)
{
	int a = 0;
	for(a;a<k;a++)
	_delay_ms(1);
}

void song()
{	
	int z;
	int l = 0;
	int lenght=sizeof(tune1)/sizeof(int);
	TCCR0A = 0b01000010;
	TCCR0B = 0b00000100; //PD6
	TCCR2A = 0b01000010;
	TCCR2B = 0b00000100; //PB3
	TCNT0 = 0;
	TCNT2 = 0;
	while (1){
	while(1){
		for (l=0;l<lenght;l++)
		{
			if ((PINC & 0b00001000) == 0)
			{
				_delay_ms(100);
				break;
			}
			else
			{
				z = 10000*duration1[l];
				hz1(tune1[l]);
				hz2(tune1[l]);
				delay(z);
				TCCR0B = 0b00000000;
				TCCR2B = 0b00000000;
				_delay_ms(100);
			}	
		}
	break;	
	}
}}
main()
{
	DDRB = (1 << PB3);
	PORTB &= ~(1 << PB3);
	DDRD = (1 << PD6);
	PORTD &= ~(1 << PD6);
	DDRC  &= 0b11110111;  // ให้ PC3 เป็นอินพุท บิตอื่นไม่เปลี่ยนแปลง
	PORTC |= 0b00001000;  // เปิดใช้ pull-up ที่ขา PC3
	DDRC  |= 0b00000111;    // ให้ PC0-PC2 เป็นเอาท์พุท บิตอื่นไม่เปลี่ยน
	PORTC |= 0b00000000;    // ให้ PC0,PC1 มีลอจิก 1 บิตอื่นไม่เปลี่ยน
	//PORTC &= 0b11111011;    // ให้ PC2 มีลอจิก 0 บิตอื่นไม่เปลี่ยน
	while(1)
	{	_delay_ms(100);
		while((PINC & 0b00001000) != 0)
		{
			_delay_ms(10);
		}
		while((PINC & 0b00001000) == 0)
		{
			_delay_ms(10);
		}
		_delay_ms(10);		
		song();
	}
}
